# 数蛙物互联网Saas成平台

## 前言
   
   数蛙团队2016年之前，在互联网和移动互联网爬坑多年，2016年开始进入物联网爬坑，希望通过这个开源平台把多年爬坑经验共享出来，让多学科交叉的工业互联网项目变得更简单。
   
   - 让丰富工程人员可以通过视窗交互可以完成需求较简单的工业互联网项目
   
   - 让广大的初级前端工程师通过serverless的方式可以承接需求较复杂的工业互联网项目
   
   - 让Python、Java、Go、C初级后台工程师通过web编程开发通道来承接复杂的工业互联网项目
   
   工业互联网落地过程是IT和OT持续融合的过程，也是技术领域和业务领域持续融合的过程。会者不难，难着不会，要把工业互联网项目变得简单一些，主要还是需要依赖于各个领域的专家围绕业务场景进行信息流的无缝路由，构建一张多学科融合的知识路由表。
   
   基于数蛙工业物联网持续集成平台可以让学者多学科交叉的知识路由表中发布学术论文，技者在实战中练就快速消化项目的本领和收入回报，商者围绕实际项目找到盈利商机。
  
# 愿景

  数蛙团队希望通过数蛙工业互联网持续集成平台达成下面一些愿景：
  
  + 通过工程人员、前端工程师、初级后台工程师在不超过1个月的实际完成中小型的工业互联网项目
  
  + 通过代码开源、软件免费、文档共享、技术认证、产品认证、运维托管等多种方式保证高质量的交付
  
  + 技术领域专家不断持续集成业界优秀技术框架、业务领域专家不断持续优化业务模型和流程、构建多学科交叉的开放平台
  
  + 近朱者赤，数蛙工业互联网持续集成平台将学习10个的工业互联网业界标杆，对接100个优秀行业软件
  
  
# 产品
  
   + 边缘侧系列产品
   
   + 云端系统产品

# 业界标杆

 | 业界标杆  | 平台插件  |  说明 |
| ------------ | ------------ | ------------ |
| 阿里云物模型  | dgiot_thing  | 物模型  |
|  亚马逊 |   |   |
|   |   |   |
|   |   |   |
|   |   |   |
|   |   |   |
|   |   |   |



# 行业软件

 | 行业软件  | 平台插件  |  说明 | 
| ------------ | ------------ | ------------ |
| 微信  | dgiot_wechat  | 微信  |
| 微信公众号  | dgiot_wx  |  微信公众号 |
| 微信小程序  | dgiot_mini-_program  |  微信小程序 |
| 百度地图  | dgiot_baidumap | 百度地图  |
|  kafka | dgiot_kafka | kafka桥接   |
|  mysql | dgiot_mysql | mysql集成   |
|  postgres | dgiot_postgres | postgres集成   |
|  TDengine | dgiot_td | TD集成   |
|  Grafana | dgiot_grafana | Grafana   |
|  Prometheus | dgiot_prometheus | Prometheus集成   |
|  gitlab |  dgiot_gitlab | 代码提交  |
|  jenkins | dgiot jenkins |  持续集成|
|  MES | dgiot_mes  | mes集成  |
| 金蝶ERP  | dgiot_erp  |  erp集成 |

# 构建

+   Linux/Unix/Mac构建
```shell
git clone https://hub.fastgit.org/dgiot/dgiot_server.git
make
```
+ windows构建
 ```
 下载msys64
 
git clone https://hub.fastgit.org/dgiot/dgiot_server.git
make
 ```

## 预览地址

[腾讯云预览地址](https://dgiotdashboard-8gb17b3673ff6cdd-1253666439.ap-shanghai.app.tcloudbase.com?ftom=git)

## 扫码预览

![dgiot_dashboard.png](http://dgiot-1253666439.cos.ap-shanghai-fsi.myqcloud.com/wechat/dgiot_dashboard.png)

## 环境要求

- node > 14.5

### 关于我们

| 联系方式       | 地址                                                                                      |
| -------------- | ----------------------------------------------------------------------------------------- |
| github         | [https://github.com/dgiot](https://github.com/dgiot?from=git)                             |
| gitee          | [https://gitee.com/dgiot](https://gitee.com/dgiiot?from=git)                              |
| 官网           | [https://www.iotn2n.com](https://www.iotn2n.com?from=git)                                 |
| 博客           | [https://tech.iotn2n.com](https://tech.iotn2n.com?from=git)                               |
| 物联网接入平台 | [https://dgiot.iotn2n.com](https://dgiot.iotn2n.com?from=git)                             |
| 公众号         | ![qrcode.png](http://dgiot-1253666439.cos.ap-shanghai-fsi.myqcloud.com/wechat/qrcode.png) |
