# -*- coding:utf-8 -*-
# @Description: 获取所有图片链接
# @Time : 2020/12/17
# @Author: vivi
# @File : getAllfiles.py.py
# pip install beautifulsoup4
# pip install lxml
# pip install html5lib

import os
import requests
import json
import base64
from bs4 import BeautifulSoup
import time
import paho.mqtt.client as mqtt

groupSession = ''
s = requests.session()
host = 'pump.iotn2n.com'
globalAclRow = {}
globalEnv = {}

mqttclient = None
mqttclinetid = "clinetid"

def on_connect(client, userdata, flags, rc):
    print("Connected with result code: " + "{}".format(rc) )

def on_message(client, userdata, msg):
    print(msg.topic + " " + "{}".format(msg))

def printf(payload):
    global mqttclient
    global mqttclinetid
    if mqttclient == None:
        mqttclient = mqtt.Client(mqttclinetid, clean_session=True, userdata=None, protocol=3, transport="tcp") #指定mqtt协议为3.1版本，满足模糊匹配需求
        mqttclient.username_pw_set('shuwalog', password="session")
        mqttclient.on_connect = on_connect
        mqttclient.on_message = on_message
        mqttclient.connect('127.0.0.1', 1883, 60)
        mqttclient.loop_start()
    # client.subscribe('#', qos=0)  #订阅的topic
    strbody = '{}'.format(payload)
    enbody =  base64.b64encode(strbody.encode('utf-8'))
    mqttclient.publish(mqttclinetid, '{}'.format(enbody))
    print(payload)

def post_before(session):
    global mqttclinetid
    mqttclinetid = session
    printf("init")

def post_after():
    global mqttclinet
    mqttclinet.disconnect()

def login():
    url = 'http://{}/iotapi/login'.format(host)
    headers = {'accept': 'application/json', "Content-Type": "text/plain"}
    body = {"username": 'liou_zh', "password": 'liou_zh'}
    r = s.post(url, headers=headers, data=json.dumps(body))
    global  globalEnv
    globalEnv = json.loads(r.content)  # 解码JSON对象
    global groupSession
    groupSession = r.json()['sessionToken']
    s.headers.update({"sessionToken": groupSession, 'Content-Type': 'application/json'})

def get_img(name, url, session,state):
    '''获取每张图片的内容'''
    headers = {
        'Accept':'image/webp,image/apng,image/*,*/*;q=0.8',
        'Accept-Encoding':'gzip, deflate',
        'Accept-Language':'zh-CN,zh;q=0.9',
        'Connection':'keep-alive',
        'Host': 'i.meizitu.net',
        'Referer': 'http://www.mzitu.com/%s'%name,
        'user-agent': 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36'
    }
    image = requests.get(url,headers=headers).content
    #print(image)
    localtime = time.strftime("%Y-%m-%d-%H-%M-%S", time.localtime())
    img_file_name = localtime + '.png'
    with open(img_file_name,'wb') as f:
        f.write(image)
    return upload(img_file_name,session,state)

def upload(file,session,state):
    role = state['roles'][0]['name']
    fileurl = state['roles'][0]['tag']['appconfig']['file']
    files = {'file': open(file, 'rb')}
    options = {'output': 'json', 'path': '', 'scene': role, 'auth_token':session}  # 参阅浏览器上传的选项
    uploadres = requests.post(fileurl,data=options, files=files)
    content = json.loads(uploadres.text)
    return content["path"]

# noinspection PyInterpreter
def getsubproduct(body, session, state, product,result):
    wordpreviewurl = state['roles'][0]['tag']['appconfig']['wordpreview']
    resturl = state['roles'][0]['tag']['appconfig']['rest']
    product = json.loads(product)
    config = product['config']
    # testword = 'http%3A%2F%2Fpump.iotn2n.com%3A8012%2Fkkfileview%2Fdemo%2F___20201209191602.doc'
    html_doc = s.get(wordpreviewurl + '/onlinePreview?url=' + body['word'] + '&officePreviewType=image')
    soup = BeautifulSoup(html_doc.content, features='html.parser')
    index = 0
    for x in soup.findAll('img', attrs={'class': 'my-photo'}):
        index = index + 1
        strindex = "{}".format(index)
        img_url = x['data-src']
        name = strindex,
        imagepath = get_img(name, img_url, session,state)
        newconfig = {
            "layer": {
                "width": 600,
                "height": 850,
                "backColor": "#eee",
                "backgroundImage": imagepath,
                "widthHeightRatio": ""
            },
            "identifier": "inspectionReportTemp_" + strindex,
            "index": index
        }
        mergeconfig = dict(config)
        mergeconfig.update(newconfig)
        newproduct = {
            "config": mergeconfig,
            "nodeType": 0,
            "desc": strindex,
            "name": body['name'] + strindex,
            "icon": imagepath
        }
        mergeproduct = dict(product)
        mergeproduct.update(newproduct)
        s.headers.update({"sessionToken": session, 'Content-Type': 'application/json'})
        rt = s.post('{}/classes/Product'.format(resturl), data=json.dumps(mergeproduct))
        data = json.loads(rt.content)
        result.append({strindex:data})

def post(args, session, env):
    post_before(session)

    body = json.loads(base64.b64decode(args).decode("utf-8"))
    state = json.loads(base64.b64decode(env).decode("utf-8"))
    resturl = state['roles'][0]['tag']['appconfig']['rest']
    role = state['roles'][0]['name']
    product = get_product(body, role)
    print(product)
    result = []
    s.headers.update({"sessionToken": session, 'Content-Type': 'application/json'})
    rt = s.post('{}/classes/Product'.format(resturl), data=product)
    data = json.loads(rt.content)
    result.append({"0":data})
    getsubproduct(body,session, state, product, result)
    print(result)
    strbody = '{}'.format(result)
    enbody = base64.b64encode(strbody.encode('utf-8'))

    post_after()
    return enbody


def get_product(body, role):
    config = {
        "name": body['name'],
        "layer": {
            "width": 600,
            "height": 850,
            "backColor": "#eee",
            "backgroundImage": "",
            "widthHeightRatio": ""},
        "deviceid": "",
        "components": [],
        "index": 0
    }
    newconfig = json.loads(body['config'])
    merge = dict(config)
    merge.update(newconfig)
    print(merge)
    acl = "role:" + role
    product = {
        "ACL": {
            acl: {
                "read": True,
                "write": True
            }
        },
        "productSecret": "productSecret",
        "config": merge,
        "icon": "",
        "nodeType": 1,
        "desc": "0",
        "devType": body['type'],
        "name": body['name'],
        "category": "Evidence"
    }
    return json.dumps(product)


def main():
    # {"name":"shuwa"}
    global groupSession
    global globalEnv
    login()
    body = {
        "config": "{\"client\":\"离心泵\",\"identifier\":\"a28b138a-0f31-fe7d-cadc-0be47faf8a8d\"}",
        "name": "南方泵业",
        "type": "潜水泵",
        "word": "http%3A%2F%2Fpump.iotn2n.com%3A8012%2Fkkfileview%2Fdemo%2F___20201209191602.doc"
    }
    data = json.JSONEncoder().encode(body)
    argvs = base64.b64encode(data.encode('utf-8'))
    print(argvs)
    data = json.JSONEncoder().encode(globalEnv)
    env = base64.b64encode(data.encode('utf-8'))
    print(env)
    return post(argvs, groupSession, env)

def exit():
    os._exit(0)


if __name__ == "__main__":
    main()
