# coding=utf8
import os
import requests
import json
import base64
from dateutil.parser import parse
import datetime
import hashlib
import time


groupSession = ''
globalEnv = {}
s = requests.session()
host = '47.110.83.36'

def login():
    url = 'http://{}:4081/iotapi/login'.format(host)
    headers = {'accept': 'application/json', "Content-Type": "text/plain"}
    body = {"username": 'sinmahedev', "password": '123456'}
    r = s.post(url, headers=headers, data=json.dumps(body))
    global globalEnv
    globalEnv = json.loads(r.content)  # 解码JSON对象
    global groupSession
    groupSession = r.json()['sessionToken']
    s.headers.update({"sessionToken": groupSession, 'Content-Type': 'application/json'})

def get_deviceid(productid,devaddr):
    data = 'Device' + productid + devaddr
    print(data)
    md5 = hashlib.md5(data.encode(encoding='UTF-8')).hexdigest()
    return  md5[0:10]

def time_data1(time_sj):                #传入单个时间比如'2019-8-01 00:00:00'，类型为str
    data_sj = time.strptime(time_sj,"%Y-%m-%d %H:%M:%S")       #定义格式
    time_int = int(time.mktime(data_sj))
    return time_int             #返回传入时间的时间戳，类型为int

def time_data2(time_sj):     #传入参数
    data_sj = time.localtime(time_sj)
    time_str = time.strftime("%Y-%m-%d %H:%M:%S",data_sj)            #时间戳转换正常时间
    return time_str       #返回日期，格式为str

def post(args,session,env):
    body = json.loads(base64.b64decode(args).decode("utf-8"))
    print(body)
    url = 'http://{}:6020/rest/sql'.format(host)
    # curl -H 'Authorization: Basic <TOKEN>' -d '<SQL>' <ip>:<PORT>/rest/sql
    # TOKEN为{username}:{password}经过Base64编码之后的字符串，例如root:taosdata编码后为cm9vdDp0YW9zZGF0YQ==
    headers = {'Authorization': 'Basic cm9vdDp0YW9zZGF0YQ=='}
    deviceid = get_deviceid(body['productid'],body['devaddr'])
    data = "select max(servicetime), max(IdleTime), max(uptime), max(downtime)  from _" + body['productid'] + "._" + deviceid + "  where createdat < now  interval(24h);"
    r = requests.post(url, headers=headers,data=data)
    t = r.content # 读取返回的内容
    t = json.loads(t) # 解码JSON对象
    print(t['data'])
    rows = []
    if(t['data'] == []):
        pass
    else:
        pre = t['data'][0]
        i = 0
        for row in (t['data']):
            # print(row)
            if i == 0:
                servicetime = row[1] / 60
                servicetime = round(servicetime, 3)

                idleTime = row[2] / 60
                idleTime = round(idleTime, 3)

                uptime = row[3] / 60
                uptime = round(uptime, 3)

                downtime = row[4] / 60
                downtime = round( downtime , 3 )
            else:
                if (row[1] - pre[1]) > 0:
                    servicetime = (row[1] - pre[1]) / 60
                    servicetime = round(servicetime, 3)
                else:
                    servicetime = row[1] / 60
                    servicetime = round(servicetime, 3)

                if (row[2] - pre[2]) > 0:
                    idleTime =(row[2] - pre[2]) / 60
                    idleTime = round(idleTime, 3)
                else:
                    idleTime = row[2]/ 60
                    idleTime = round(idleTime, 3)

                if (row[3] - pre[3]) > 0:
                    uptime = (row[3] - pre[3]) / 60
                    uptime = round( uptime , 3 )
                else:
                    uptime = row[3] / 60
                    uptime = round( uptime , 3 )
                if (row[4] - pre[4]) > 0:
                    downtime = (row[4] - pre[4]) /60
                    downtime = round( downtime , 3 )
                else:
                    downtime = row[4]  /60
                    downtime = round( downtime , 3 )

            curtime = parse(row[0])
            curtime = "{}".format(curtime)
            curtimestamp =  time_data1(curtime)

            pretime = parse(pre[0])
            pretime = "{}".format(pretime)
            pretimestamp = time_data1(pretime)
            idletimestamp = pretimestamp

            if (curtimestamp - pretimestamp) >= 60 * 60 * 24:
                count = int((curtimestamp - pretimestamp) /(60 * 60 * 24)) - 1
                for i in range(count):
                    idletimestamp = pretimestamp + (60 * 60 * 24) * (i+1)
                    idletime = time_data2(idletimestamp)
                    idletime = datetime.datetime.strptime(idletime, '%Y-%m-%d %H:%M:%S').strftime('%Y-%m-%d')
                    item = { "日期": idletime, "服务时间": 0 , "空闲时间": 0 ,"上行时间": 0, "下行时间":0}
                    print(item)
                    rows.append(item)
            if idletimestamp == curtimestamp:
                if i == 0:
                    curtime = datetime.datetime.strptime(curtime, '%Y-%m-%d %H:%M:%S').strftime('%Y-%m-%d')
                    item = { "日期": curtime, "服务时间": servicetime , "空闲时间": idleTime ,"上行时间": uptime, "下行时间":downtime}
                    print(item)
                    rows.append(item)
            else:
                curtime = datetime.datetime.strptime(curtime, '%Y-%m-%d %H:%M:%S').strftime('%Y-%m-%d')
                item = { "日期": curtime, "服务时间": servicetime , "空闲时间": idleTime ,"上行时间": uptime, "下行时间":downtime}
                print(item)
                rows.append(item)
            pre  = row
            i = i + 1
    deviceData =  {
        "columns": ["日期", "小时数"],
        "rows": rows
    }

    data = json.JSONEncoder().encode(deviceData)
    enbody = base64.b64encode(data.encode('utf-8'))
    print(enbody)
    return enbody

def main():
    global groupSession
    global globalEnv
    login()
    body = {
        "productid": "389a16cda1",
        # "devaddr": "BasicInformation_20083411"
        "devaddr": "BasicInformation_20100629"
    }

    data = json.JSONEncoder().encode(body)
    argvs = base64.b64encode(data.encode('utf-8'))
    print(argvs)
    data = json.JSONEncoder().encode(globalEnv)
    env = base64.b64encode(data.encode('utf-8'))
    print(env)
    return post(argvs, groupSession, env)

def exit():
    os._exit(0)

if __name__ == "__main__":
    main()