# -*- coding:utf-8 -*-
# @Description: 获取所有图片链接
# @Time : 2020/12/17
# @Author: vivi
# @File : getAllfiles.py.py
# pip install beautifulsoup4
# pip install lxml
# pip install html5lib

import os
import requests
import json
import base64
import paho.mqtt.client as mqtt
import time

groupSession = ''
globalEnv = {}
s = requests.session()
host = '124.156.217.175'

mqttclient = None
mqttclinetid = "clinetid"

def on_connect(client, userdata, flags, rc):
    print("Connected with result code: " + "{}".format(rc) )

def on_message(client, userdata, msg):
    print(msg.topic + " " + "{}".format(msg) )

def printf(payload):
    global mqttclient
    global mqttclinetid
    if mqttclient == None:
        mqttclient = mqtt.Client(mqttclinetid, clean_session=True, userdata=None, protocol=3, transport="tcp") #指定mqtt协议为3.1版本，满足模糊匹配需求
        mqttclient.username_pw_set('shuwalog', password="session")
        mqttclient.on_connect = on_connect
        mqttclient.on_message = on_message
        mqttclient.connect('127.0.0.1', 1883, 60)
        mqttclient.loop_start()
    # client.subscribe('#', qos=0)  #订阅的topic
    strbody = '{}'.format(payload)
    enbody =  base64.b64encode(strbody.encode('utf-8'))
    mqttclient.publish(mqttclinetid, '{}'.format(enbody))
    print(payload)

def post_before(session):
    global mqttclinetid
    mqttclinetid = session
    printf("init")

def post_after():
    global mqttclinet
    mqttclinet.disconnect()

def login():
    url = 'http://{}/iotapi/login'.format(host)
    headers = {'accept': 'application/json', "Content-Type": "text/plain"}
    body = {"username": 'toppansale', "password": 'toppansale'}
    r = s.post(url, headers=headers, data=json.dumps(body))
    global globalEnv
    globalEnv = json.loads(r.content)  # 解码JSON对象
    global groupSession
    groupSession = r.json()['sessionToken']
    s.headers.update({"sessionToken": groupSession, 'Content-Type': 'application/json'})


def upload(file, session, state):
    role = state['roles'][0]['name']
    fileurl = state['roles'][0]['tag']['appconfig']['file']
    files = {'file': open(file, 'rb')}
    options = {'output': 'json', 'path': '', 'scene': role, 'auth_token': session}  # 参阅浏览器上传的选项
    uploadres = requests.post(fileurl, data=options, files=files)
    content = json.loads(uploadres.text)
    return content["path"]


def get_prometheus_query_range(job, prometheus, query, start, end, step):
    '''查询prometheus指定时间段数据'''
    print(query)
    url = 'http://' + prometheus + '/api/v1/query_range?query=' + query + '&start=' + start + '&end=' + end + '&step=' + step
    print(url)
    content = json.loads(requests.get(url).content)
    for x in content['data']['result']:
        print(x)


def search_prometheus_target(prometheus):
    '''查询prometheus所有在线对象'''
    url = 'http://' + prometheus + '/api/v1/query?query=up'
    rt = json.loads(requests.get(url).content)
    print(rt)
    return rt


def get_prometheus_target(job, prometheus):
    '''获取prometheus指定对象详情'''
    print(job)
    url = 'http://' + prometheus + '/api/v1/query?query=up'
    rt = json.loads(requests.get(url).content)
    for x in rt['data']['result']:
        if job == x['metric']['job']:
            return x


# def get_prometheus_target(prometheus):
#     '''获取prometheus指定对象详情'''
#     url = 'http://' + prometheus + '/api/v1/query?query=up'
#     rt = json.loads(requests.get(url).content)
#     for x in rt['data']['result']:
#         return x


def get_render_image(target, grafana, session, state):
    '''获取grafana面板信息并上传图片到指定服务器'''
    start = '1609297614229'
    end = '1609297914230'
    panelId = '158'
    url = 'http://' + grafana + '/render/d-solo/9CWBz0bik/zetaya-ce-jian-kong?from=' + start \
          + '&to=' + end + '&orgId=1&var-job=' + target['metric']['job'] \
          + '&var-hostname=All&var-node=' + target['metric']['instance'] \
          + '&var-device=All&var-maxmount=%2F&panelId=' + panelId \
          + '&width=1000&height=500&tz=Asia%2FShanghai'
    authorizationkey = 'Bearer eyJrIjoiRVU2TDF1YUFQdFlXempqS1FHOU80RTdHd1BEbzlqUTgiLCJuIjoiMjM0a2V5IiwiaWQiOjF9'
    headers = {
        'AuthorizationKey': authorizationkey,
        'Accept': 'image/webp,image/apng,image/*,*/*;q=0.8',
        'Accept-Encoding': 'gzip, deflate',
        'Accept-Language': 'zh-CN,zh;q=0.9',
        'Connection': 'keep-alive',
        'Host': 'i.meizitu.net',
        'Referer': 'http://www.mzitu.com/%s' % target['metric']['job'],
        'user-agent': 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36'
    }
    image = requests.get(url, headers=headers).content
    # print(image)
    localtime = time.strftime("%Y-%m-%d-%H-%M-%S", time.localtime())
    img_file_name = localtime + '.png'
    with open(img_file_name, 'wb') as f:
        f.write(image)
    return upload(img_file_name, session, state)


def search_grafana_dashboard(grafana):
    '''查询grafana所有面板'''
    url = 'http://' + host + '/api/search'
    authorizationkey = 'Bearer eyJrIjoiRVU2TDF1YUFQdFlXempqS1FHOU80RTdHd1BEbzlqUTgiLCJuIjoiMjM0a2V5IiwiaWQiOjF9'
    headers = {
        'AuthorizationKey': authorizationkey,
        'Accept': 'application/json',
        'Content-Type': 'application/json'
    }
    return json.loads(requests.get(url, headers=headers).content)


def get_grafana_dashboard(uid, grafana):
    '''查询grafana面板详情'''
    url = 'http://' + grafana + '/api/dashboards/uid/' + uid
    authorizationkey = 'Bearer eyJrIjoiRVU2TDF1YUFQdFlXempqS1FHOU80RTdHd1BEbzlqUTgiLCJuIjoiMjM0a2V5IiwiaWQiOjF9'
    headers = {
        'AuthorizationKey': authorizationkey,
        'Accept': 'application/json',
        'Content-Type': 'application/json'
    }
    print(url)
    rt = json.loads(requests.get(url, headers=headers).content)
    print(rt['dashboard']['panels'])
    start = '1606825194000'
    end = '1609417223000'
    target = get_prometheus_target('testcenter',grafana)
    print('grafana',grafana)
    jkong = rt['meta']['slug']
    job = target['metric']['job']
    node = target['metric']['instance']
    arr = []
    for x in rt['dashboard']['panels']:
        strid = str(x['id'])
        imgurl = 'http://' + grafana + '/render/d-solo/'+uid+'/'+ jkong + '?from=' + start + '&to=' + end + '&orgId=1&var-job=' + job + '&var-node=' + node+ '&panelId=' + strid
        item = {
            'category':"grafana",
            "tag": 'grafana',
            "type": "image",
            "name": x['title'],
            "url": imgurl,
            "height": '500',
            "width": "1000"

        }
        arr.append(item)
        # newconfig = {
        #     "layer": {
        #         "width": 600,
        #         "height": 850,
        #         "backColor": "#eee",
        #         "backgroundImage": imagepath,
        #         "widthHeightRatio": ""
        #     },
        #     "identifier": "inspectionReportTemp_" + strindex,
        #     "index": index
        # }
        # mergeconfig = dict(config)
        # mergeconfig.update(newconfig)
    return json.dumps(arr)


def get_zeta(args, session, env):
    print()


def get_zetag(args, session, env):
    print()


def get_grafana(args, session, env):
    print()


def get_pomtheus(args, session, env):
    print()


def get_zeta_mqtt(args, session, env):
    print()


def get_zetag_kafka(args, session, env):
    print()


def get_zeta_http(args, session, env):
    print()


def get_zetag_http(args, session, env):
    print()


def get_loran(args, session, env):
    print()


def post(args, session, env):
    '''zeta压测报告API实现'''
    body = json.loads(base64.b64decode(args).decode("utf-8"))
    state = json.loads(base64.b64decode(env).decode("utf-8"))
    resturl = state['roles'][0]['tag']['appconfig']['rest']
    wordproduct = state['roles'][0]['tag']['appconfig']['wordproduct']
    print(wordproduct)
    print(resturl)
    role = state['roles'][0]['name']
    print(body)
    global host
    print(body['reportId'])
    s.headers.update({"sessionToken": session, 'Content-Type': 'application/json'})
    rt = s.get('http://' + host + '/iotapi/classes/Device?order=createdAt&limit=1&skip=0',
               params={'where': json.dumps({"objectId": body['reportId']})})
    print(rt)

    datas = {}
    textdata = []
    text = {'text': textdata}
    imagedata = []
    image = {'image': imagedata}
    tabledata = []
    table = {'table': tabledata}
    datas.update(text)
    datas.update(image)
    datas.update(table)

    for row in (rt.json()['results']):
        datas.update(row)

    dashborad = get_grafana_dashboard('9CWBz0bik', host)

    print(dashborad)

    # query = 'increase(http{exported_instance="124.156.217.175", exported_job="zeta_metrics", instance="iot", job="shuwa", key="getWanAccessToken_succ"}[1m])'
    # start = '2020-12-23T20:10:30.781Z'
    # end = '2020-12-30T20:11:00.781Z'
    # step = '15m'
    # get_prometheus_query_range('up', host, query, start, end, step)

    # target = get_prometheus_target('toppan_zetag', host)
    # print(target)
    #
    # image = get_render_image(target, host, session, state)
    # print(image)

    strbody = '{}'.format(datas)
    enbody = base64.b64encode(strbody.encode('utf-8'))
    return enbody


def main():
    global groupSession
    global globalEnv
    login()
    body = {
        "reportId": "QuByOMIk3i"
    }
    data = json.JSONEncoder().encode(body)
    argvs = base64.b64encode(data.encode('utf-8'))
    print(argvs)
    data = json.JSONEncoder().encode(globalEnv)
    env = base64.b64encode(data.encode('utf-8'))
    print(env)
    return post(argvs, groupSession, env)


def exit():
    os._exit(0)


if __name__ == "__main__":
    main()
