# coding=utf8
import sys
import os
import requests
import json
import base64
import matplotlib.pyplot as plt
from pylab import mpl
import math
import time

s = requests.session()
host = 'pump.iotn2n.com'

"""完成拟合曲线参数计算前相应变量的计算"""
def polynomial_fitting(data_x,data_y):
    size=len(data_x)
    i=0
    sum_x = 0
    sum_sqare_x =0
    sum_third_power_x = 0
    sum_four_power_x = 0
    average_x = 0
    average_y = 0
    sum_y = 0
    sum_xy = 0
    sum_sqare_xy = 0
    while i<size:
        sum_x += data_x[i]
        sum_y += data_y[i]
        sum_sqare_x += math.pow(data_x[i],2)
        sum_third_power_x +=math.pow(data_x[i],3)
        sum_four_power_x +=math.pow(data_x[i],4)
        sum_xy +=data_x[i]*data_y[i]
        sum_sqare_xy +=math.pow(data_x[i],2)*data_y[i]
        i += 1;
    average_x=sum_x/size
    average_y=sum_y/size
    return [[size, sum_x, sum_sqare_x, sum_y]
        , [sum_x, sum_sqare_x, sum_third_power_x, sum_xy]
        , [sum_sqare_x,sum_third_power_x,sum_four_power_x,sum_sqare_xy]]


"""完成拟合曲线参数的计算
 其中解方程的时候，利用高斯消元法计算相应的参数值
"""
def calculate_parameter(data):
    #i用来控制列元素，line是一行元素,j用来控制循环次数,datas用来存储局部变量。保存修改后的值
    i = 0;
    j = 0;
    line_size = len(data)

    #将行列式变换为上三角行列式
    while j < line_size-1:
        line = data[j]
        temp = line[j]
        templete=[]
        for x in line:
            x=x/temp
            templete.append(x)
        data[j]=templete
        #flag标志应该进行消元的行数
        flag = j+1
        while flag < line_size:
            templete1 = []
            temp1=data[flag][j]
            i = 0
            for x1 in data[flag]:
                if x1!=0:
                    x1 = x1-(temp1*templete[i])
                    templete1.append(x1)
                else:
                    templete1.append(0)
                i += 1
            data[flag] = templete1
            flag +=1
        j += 1


    #求相应的参数值
    parameters=[]
    i=line_size-1
    #j标识减去元素个数
    #flag_rol标识除那一列
    flag_j=0
    rol_size=len(data[0])
    flag_rol=rol_size-2
    #获得解的个数
    while i>=0:
        operate_line = data[i]
        if i==line_size-1:
            parameter=operate_line[rol_size-1]/operate_line[flag_rol]
            parameters.append(parameter)
        else:
            flag_j=(rol_size-flag_rol-2)
            temp2=operate_line[rol_size-1]
            #result_flag为访问已求出解的标志
            result_flag=0
            while flag_j>0:
                temp2-=operate_line[flag_rol+flag_j]*parameters[result_flag]
                result_flag+=1
                flag_j-=1
            parameter=temp2/operate_line[flag_rol]
            parameters.append(parameter)
        flag_rol-=1
        i-=1
    return parameters

"""计算拟合曲线的值"""
def calculate(data_x,parameters):
    datay=[]
    for x in data_x:
        datay.append(parameters[2]+parameters[1]*x+parameters[0]*x*x)
    return datay

"""完成函数的绘制"""
def draw(flow, newhead, head,  newpower, power, neweffect, effect):
    plt.plot(flow, newhead,label="HQ拟合曲线",color="black")
    plt.scatter(flow, head,label="HQ离散数据")

    plt.plot(flow, newpower, label="PQ拟合曲线",color="red")
    plt.scatter(flow[:0], power[:0], label="PQ离散数据")

    plt.plot(flow, neweffect,label="EQ拟合曲线",color="blue")
    plt.scatter(flow, effect,label="EQ离散数据")

    mpl.rcParams['font.sans-serif'] = ['SimHei']
    mpl.rcParams['axes.unicode_minus'] = False

    plt.title("性能曲线拟合数据")
    plt.legend(loc= "best")
    #获取当前时间
    # ticks = time.time()
    # file = "./" + '{}'.format(ticks) + ".png",
    plt.savefig("./ffff.png")
    plt.show()
    # return file


def post(args,session,env):
    body = json.loads(base64.b64decode(args).decode("utf-8"))
    print(body)
    # strbody = '{}'.format(body)
    # enbody =  base64.b64encode(strbody.encode('utf-8'))
    # print(enbody)
    state = json.loads(base64.b64decode(env).decode("utf-8"))
    print(state)
    # resturl = state['roles'][0]['tag']['appconfig']['rest']
    # print(resturl)
    # s.headers.update({"sessionToken": session, 'Content-Type': 'application/json'})
    # rt = s.get('{}/classes/Device?order=createdAt&limit=10&skip=0'.format(resturl),
    #              params={'order': 'createdAt', })
    # for row in (rt.json()['results']):
    #     print(row)

    url = 'http://{}:6020/rest/sql'.format(host)
    # curl -H 'Authorization: Basic <TOKEN>' -d '<SQL>' <ip>:<PORT>/rest/sql
    # TOKEN为{username}:{password}经过Base64编码之后的字符串，例如root:taosdata编码后为cm9vdDp0YW9zZGF0YQ==
    headers = {'Authorization': 'Basic cm9vdDp0YW9zZGF0YQ=='}
    data = "select flow, head, effect, power from _" + body['productid'] + "._" + body['deviceid'] + " order by createdat desc limit 20;"
    r = requests.post(url, headers=headers,data=data)
    t = r.content # 读取返回的内容
    t = json.loads(t) # 解码JSON对象
    flow = []
    head = []
    effect = []
    power = []
    for row in (t['data']):
        flow.append(row[0])
        head.append(row[1])
        effect.append(row[2])
        power.append(row[3])
    print(flow)
    print(head)
    print(effect)
    print(power)
    flow =   [0.00,    40.23,  80.96,  119.79,  140.04,  159.15, 178.80, 199.32, 222.22, 240.05, 251.51, 261.26, 282.35, 299.60, 322.74, 339.06, 358.94, 380.77]
    head =   [43.55,   44.12,  43.12,  41.45,   40.97,   40.11,  39.07,  37.57,  35.43,  34.01,  32.93,  32.10,  30.70,  29.33,  26.70,  25.27,  22.76,  19.67]
    power = [14.500,  16.426, 18.310, 20.769,  22.195,  23.565, 24.971, 25.936, 26.856, 27.367, 27.946, 28,341, 29.017, 29.543, 30.148, 30.426, 30.822, 30.871]
    effect = [0.00,   4.824,   9.488,  13.495,  15.593,  17.345, 18.987, 20.352, 21.402, 22.188, 22.509, 22.792, 23.559, 23.878, 23.419, 23.287, 22.206, 20.359]

    headdata=polynomial_fitting(flow,head)
    headparameters=calculate_parameter(headdata)
    newhead=calculate(flow,headparameters)

    powerdata=polynomial_fitting(flow,power)
    powerparameters=calculate_parameter(powerdata)
    newpower=calculate(flow, powerparameters)

    effectdata=polynomial_fitting(flow,effect)
    effectparameters=calculate_parameter(effectdata)
    neweffect=calculate(flow,effectparameters)
    print(body['reportid'])
    print(state['username'])
    draw(flow, newhead, head, newpower, power, neweffect, effect)
    # upload(file, state['username'], session)
    return args

def upload(file, rolename, session):
    url = 'http://{}:1250/shapes/upload'.format(host)
    files = {'file': open(file,'rb')}
    options = {'output': 'json', 'path': '', 'scene': rolename, 'auth_token':session}  # 参阅浏览器上传的选项
    uploadres = requests.post(url, data=options, files=files)
    content = json.loads(uploadres.text)
    print("uploadImg is " + content["url"])
    return  content["url"]

def main(argvs):
    post(argvs[0], argvs[1])
    #login()
    #device()
    #upload()
    return 0

def exit():
    os._exit(0)


if __name__ == "__main__":
   main(sys.argv[1:])