# -*- coding:utf-8 -*-
# @Description: 获取所有图片链接
# @Time : 2020/12/17
# @Author: vivi
# @File : getAllfiles.py.py
# pip install beautifulsoup4
# pip install lxml
# pip install html5lib

import os
import requests
import json
import base64
from bs4 import BeautifulSoup
import time

groupSession = ''
s = requests.session()
host = 'pump.iotn2n.com'
globalAclRow = {}
globalEnv = {}

def login():
    url = 'http://{}/iotapi/login'.format(host)
    headers = {'accept': 'application/json', "Content-Type": "text/plain"}
    body = {"username": 'liou_test', "password": 'liou_test'}
    r = s.post(url, headers=headers, data=json.dumps(body))
    global  globalEnv
    globalEnv = json.loads(r.content)  # 解码JSON对象
    global groupSession
    groupSession = r.json()['sessionToken']
    s.headers.update({"sessionToken": groupSession, 'Content-Type': 'application/json'})

def get_img(name, url, session,state):
    '''获取每张图片的内容'''
    headers = {
        'Accept':'image/webp,image/apng,image/*,*/*;q=0.8',
        'Accept-Encoding':'gzip, deflate',
        'Accept-Language':'zh-CN,zh;q=0.9',
        'Connection':'keep-alive',
        'Host': 'i.meizitu.net',
        'Referer': 'http://www.mzitu.com/%s'%name,
        'user-agent': 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36'
    }
    image = requests.get(url,headers=headers).content
    #print(image)
    localtime = time.strftime("%Y-%m-%d-%H-%M-%S", time.localtime())
    img_file_name = localtime + '.png'
    with open(img_file_name,'wb') as f:
        f.write(image)
    return upload(img_file_name,session,state)

def upload(file,session,state):
    role = state['roles'][0]['name']
    fileurl = state['roles'][0]['tag']['appconfig']['file']
    files = {'file': open(file, 'rb')}
    options = {'output': 'json', 'path': '', 'scene': role, 'auth_token':session}  # 参阅浏览器上传的选项
    uploadres = requests.post(fileurl,data=options, files=files)
    content = json.loads(uploadres.text)
    return content["path"]

# noinspection PyInterpreter
def getsubproduct(body, session, state, product,result):
    wordpreviewurl = state['roles'][0]['tag']['appconfig']['wordpreview']
    resturl = state['roles'][0]['tag']['appconfig']['rest']
    product = json.loads(product)
    config = product['config']
    print(wordpreviewurl)
    # testword = 'http%3A%2F%2Fpump.iotn2n.com%3A8012%2Fkkfileview%2Fdemo%2F___20201209191602.doc'
    # html_doc = s.get(wordpreviewurl + '/kkfileview/onlinePreview?url=' + body['word'] + '&officePreviewType=image')
    # html_doc = s.get('http://pump.iotn2n.com:8012/kkfileview/onlinePreview?url=http%3A%2F%2Fpump.iotn2n.com%3A8012%2Fkkfileview%2Fdemo%2F%E6%B0%B4%E6%B3%B5%E4%B8%AD%E5%BF%83%E6%B0%B4%E6%B3%B5%E6%8A%A5%E5%91%8A%E6%BC%94%E7%A4%BA%E7%89%88333.pdf&officePreviewType=image')
    html_doc = s.get('http://pump.iotn2n.com:8012/kkfileview/onlinePreview?url=http%3A%2F%2Fpump.iotn2n.com%3A8012%2Fkkfileview%2Fdemo%2F1000S20_2020122801_%E9%94%80%EF%BC%9A%E5%8D%97%E6%B0%B4%E5%8C%97%E8%B0%83%20%E4%B8%9C%E5%B9%B2%E6%B8%A0_202012286162842.pdf&officePreviewType=image')

    print(html_doc)
    soup = BeautifulSoup(html_doc.content, features='html.parser')
    index = 0
    for x in soup.findAll('img', attrs={'class': 'my-photo'}):
        index = index + 1
        strindex = "{}".format(index)
        img_url = x['data-src']
        name = strindex,
        imagepath = get_img(name, img_url, session,state)
        newconfig = {
            "layer": {
                "width": 600,
                "height": 850,
                "backColor": "#eee",
                "backgroundImage": imagepath,
                "widthHeightRatio": ""
            },
            "identifier": "inspectionReportTemp_" + strindex,
            "index": index
        }
        mergeconfig = dict(config)
        mergeconfig.update(newconfig)
        newproduct = {
            "config": mergeconfig,
            "nodeType": 0,
            "desc": strindex,
            "name": body['name'] + strindex,
            "icon": imagepath
        }
        mergeproduct = dict(product)
        mergeproduct.update(newproduct)
        s.headers.update({"sessionToken": session, 'Content-Type': 'application/json'})
        rt = s.post('{}/classes/Product'.format(resturl), data=json.dumps(mergeproduct))
        data = json.loads(rt.content)
        result.append({strindex:data})

def post(args, session, env):
    body = json.loads(base64.b64decode(args).decode("utf-8"))
    state = json.loads(base64.b64decode(env).decode("utf-8"))
    resturl = state['roles'][0]['tag']['appconfig']['rest']
    role = state['roles'][0]['name']
    product = get_product(body, role)
    print(product)
    result = []
    s.headers.update({"sessionToken": session, 'Content-Type': 'application/json'})
    rt = s.post('{}/classes/Product'.format(resturl), data=product)
    data = json.loads(rt.content)
    result.append({"0":data})
    getsubproduct(body,session, state, product, result)
    print(result)
    strbody = '{}'.format(result)
    enbody = base64.b64encode(strbody.encode('utf-8'))
    return enbody


def get_product(body, role):
    config = {
        "name": body['name'],
        "layer": {
            "width": 600,
            "height": 850,
            "backColor": "#eee",
            "backgroundImage": "",
            "widthHeightRatio": ""},
        "deviceid": "",
        "components": [],
        "index": 0
    }
    newconfig = json.loads(body['config'])
    merge = dict(config)
    merge.update(newconfig)
    print(merge)
    acl = "role:" + role
    product = {
        "ACL": {
            acl: {
                "read": True,
                "write": True
            }
        },
        "productSecret": "productSecret",
        "config": merge,
        "icon": "",
        "nodeType": 1,
        "desc": "0",
        "devType": body['type'],
        "name": body['name'],
        "category": "Evidence"
    }
    return json.dumps(product)


def main():
    # {"name":"shuwa"}
    global groupSession
    global globalEnv
    login()
    body = {
        "config": "{\"client\":\"中开泵\",\"identifier\":\"a283149a-0f31-fe7d-cadc-0be47faf8a8d\"}",
        "name": "利欧南水北调中开泵检测",
        "type": "中开泵",
        "word": "http%3A%2F%2Fpump.iotn2n.com%3A8012%2Fkkfileview%2Fdemo%2F水泵中心水泵报告演示版333.pdf"
    }
    data = json.JSONEncoder().encode(body)
    argvs = base64.b64encode(data.encode('utf-8'))
    print(argvs)
    data = json.JSONEncoder().encode(globalEnv)
    env = base64.b64encode(data.encode('utf-8'))
    print(env)
    return post(argvs, groupSession, env)


if __name__ == "__main__":
    main()
