# -*- coding:utf-8 -*-
# @Description: 获取所有图片链接
# @Time : 2020/12/17
# @Author: vivi
# @File : getAllfiles.py.py
# pip install beautifulsoup4
# pip install lxml
# pip install html5lib

import os
import requests
import json
import base64
import time
import hashlib
import paho.mqtt.client as mqtt
from pathlib import Path
from urllib import parse
import random
import math

groupSession = ''
globalEnv = dict({'host': '124.156.217.175'})
s = requests.session()
host = '124.156.217.175'

def on_connect(client, userdata, flags, rc):
    print("Connected with result code: " + "{}".format(rc))


def on_message(client, userdata, msg):
    print(msg.topic + " " + "{}".format(msg))

def publish(topic, payload, host):
    session = time.strftime("%Y-%m-%d-%H-%M-%S", time.localtime())
    mqttclient = mqtt.Client(session, clean_session=True, userdata=None, protocol=3,
                             transport="tcp")  # 指定mqtt协议为3.1版本，满足模糊匹配需求
    mqttclient.username_pw_set('shuwalog', password="session")
    mqttclient.on_connect = on_connect
    mqttclient.on_message = on_message
    mqttclient.connect(host, 1883, 60)
    mqttclient.loop_start()
    mqttclient.subscribe('#', qos=0)
    time.sleep(1)
    mqttclient.publish(topic, payload)
    time.sleep(3)
    mqttclient.loop_stop()
    mqttclient.disconnect()


def login():
    url = 'http://{}/iotapi/login'.format(host)
    headers = {'accept': 'application/json', "Content-Type": "text/plain"}
    body = {"username": 'toppan', "password": 'toppan'}
    r = s.post(url, headers=headers, data=json.dumps(body))
    global globalEnv
    newEvn = json.loads(r.content)
    globalEnv = dict(globalEnv, **newEvn)
    global groupSession
    groupSession = r.json()['sessionToken']
    s.headers.update({"sessionToken": groupSession, 'Content-Type': 'application/json'})


def upload(file, session, state):
    role = state['roles'][0]['name']
    fileurl = state['roles'][0]['tag']['appconfig']['file']
    files = {'file': open(file, 'rb')}
    options = {'output': 'json', 'path': role, 'scene': role, 'auth_token': session}  # 参阅浏览器上传的选项
    uploadres = requests.post(fileurl, data=options, files=files)
    content = json.loads(uploadres.text)
    return content["path"]


def get_prometheus_query_range(prometheus, query, start, end, step):
    '''查询prometheus指定时间段数据'''
    print(query)
    url = 'http://' + prometheus + '/api/v1/query_range?query=' + query + '&start=' + start + '&end=' + end + '&step=' + step
    print(url)
    content = json.loads(requests.get(url).content)
    for x in content['data']['result']:
        print(x)


def get_prometheus_query(prometheus, query, start, end, step):
    '''查询prometheus指定时间段数据'''
    url = 'http://' + prometheus + '/api/v1/query?query=' + query + '&start=' + start + '&end=' + end + '&step=' + step
    #print(url)
    content = json.loads(requests.get(url).content)
    return content


def search_prometheus_target(prometheus):
    '''查询prometheus所有在线对象'''
    url = 'http://' + prometheus + '/api/v1/targets'
    rt = json.loads(requests.get(url).content)
    print(rt)
    targets = []
    for item in rt['data']['activeTargets']:
        if 'labels' in item:
            targets.append(item['labels'])
    return targets


def get_prometheus_target(job, prometheus):
    '''获取prometheus指定对象详情'''
    print(job)
    url = 'http://' + prometheus + '/api/v1/query?query=up'
    rt = json.loads(requests.get(url).content)
    for x in rt['data']['result']:
        if job == x['metric']['job']:
            return x


def get_prometheus_target_metadata(job, prometheus):
    '''获取prometheus指定对象详情'''
    print(job)
    url = 'http://' + prometheus + '/api/v1/targets/metadata?match_target={job=' + job + '}'
    rt = json.loads(requests.get(url).content)
    return rt['data']


def get_render_image(job, instance, host, session, state):
    '''获取grafana面板信息并上传图片到指定服务器'''
    start = '1609297614229'
    end = '1609297914230'
    panelId = '158'
    url = 'http://' + host + '/render/d-solo/9CWBz0bik/zetaya-ce-jian-kong?from=' + start \
          + '&to=' + end + '&orgId=1&var-job=' + job \
          + '&var-hostname=All&var-node=' + instance \
          + '&var-device=All&var-maxmount=%2F&panelId=' + panelId \
          + '&width=1000&height=500&tz=Asia%2FShanghai'
    authorizationkey = 'Bearer eyJrIjoiRVU2TDF1YUFQdFlXempqS1FHOU80RTdHd1BEbzlqUTgiLCJuIjoiMjM0a2V5IiwiaWQiOjF9'
    headers = {
        'AuthorizationKey': authorizationkey,
        'Accept': 'image/webp,image/apng,image/*,*/*;q=0.8',
        'Accept-Encoding': 'gzip, deflate',
        'Accept-Language': 'zh-CN,zh;q=0.9',
        'Connection': 'keep-alive',
        'Host': 'i.meizitu.net',
        'Referer': 'http://www.mzitu.com/%s' % job,
        'user-agent': 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36'
    }
    image = requests.get(url, headers=headers).content
    # print(image)
    localtime = time.strftime("%Y-%m-%d-%H-%M-%S", time.localtime())
    img_file_name = localtime + '.png'
    with open(img_file_name, 'wb') as f:
        f.write(image)
    return upload(img_file_name, session, state)


def search_grafana_dashboard(grafana):
    '''查询grafana所有面板'''
    url = 'http://' + host + '/api/search'
    authorizationkey = 'Bearer eyJrIjoiRVU2TDF1YUFQdFlXempqS1FHOU80RTdHd1BEbzlqUTgiLCJuIjoiMjM0a2V5IiwiaWQiOjF9'
    headers = {
        'AuthorizationKey': authorizationkey,
        'Accept': 'application/json',
        'Content-Type': 'application/json'
    }
    return json.loads(requests.get(url, headers=headers).content)


def get_uid(str):
    data = '{}'.format(str)
    md5 = hashlib.md5(data.encode(encoding='UTF-8')).hexdigest()
    return md5[0:10]


def get_single_grafana_data(uid, job, instance, host):
    '''查询grafana面板详情'''
    url = 'http://' + host + '/api/dashboards/uid/' + uid
    print(url)
    authorizationkey = 'Bearer eyJrIjoiRVU2TDF1YUFQdFlXempqS1FHOU80RTdHd1BEbzlqUTgiLCJuIjoiMjM0a2V5IiwiaWQiOjF9'
    headers = {
        'AuthorizationKey': authorizationkey,
        'Accept': 'application/json',
        'Content-Type': 'application/json'
    }
    rt = json.loads(requests.get(url, headers=headers).content)
    arr = []
    url = rt['meta']['url'][3:-1]
    for panel in rt['dashboard']['panels']:
        if 'targets' in panel:
            for metric in panel['targets']:
                if 'legendFormat' in metric:
                    expr = metric['expr'].replace("$node", instance)
                    expr = expr.replace("$job", job)
                    expr = expr.replace(" ", "")
                    textdata = {
                        "tag": '{{' + job + "_" + metric['legendFormat'] + '}}',
                        "type": "text",
                        "source": "auto",
                        "uid": get_uid(expr),
                        "name": job + "_" + metric['legendFormat'],
                        "expr": expr
                    }
                    #print(textdata)
                    arr = get_item(textdata, arr)
        strid = str(panel['id'])
        imgurl = 'http://' + host + '/render/d-solo/' + url + '?' + '&orgId=1&var-job=' + job + '&var-node=' + instance + '&panelId=' + strid
        image = {
            "tag": '{{@' + job + "_" + panel['title'] + '}}',
            "type": "image",
            "source": "auto",
            "uid": get_uid(job + '_' + uid + '_' + strid),
            "name": job + "_" + panel['title'],
            "url": imgurl,
            "height": '250',
            "width": "500"
        }
        #print(image)
        arr = get_item(image, arr)
    return arr


def get_item(data, arr):
    i = 0
    tmp = arr[:]
    for item in tmp:
        if item['uid'] == data['uid']:
            tmp[i] = dict(item, **data)
            return tmp
        i = i + 1
    tmp.append(data)
    return tmp

def get_json(args, session, env):
    body = json.loads(base64.b64decode(args).decode("utf-8"))
    state = json.loads(base64.b64decode(env).decode("utf-8"))
    #print(body)
    s.headers.update({"sessionToken": session, 'Content-Type': 'application/json'})
    rt = s.get('http://' + state['host'] + '/iotapi/classes/Device?order=createdAt&limit=1&skip=0',
               params={'keys': 'basedata', 'where': json.dumps({"objectId": body['reportid']})})
    #print(rt.content)
    report = json.loads(rt.content)['results'][0]
    #print(json.JSONEncoder().encode(report))
    taskinfo = report['basedata']['info']

    start = str(taskinfo['startTime'])
    day1 = int(start) / 1000
    timeArray1 = time.localtime(day1)
    otherStyleTime1 = time.strftime("%Y-%m-%d %H:%M:%S", timeArray1)
    # print(otherStyleTime1)
    end = str(taskinfo['endTime'])
    day2 = int(end) / 1000
    timeArray2 = time.localtime(day2)
    otherStyleTime2 = time.strftime("%Y-%m-%d %H:%M:%S", timeArray2)
    # print(end)
    arr = []

    # 生成json串
    item1 = {
        "tag": "{{StartTime}}",
        "type": "text",
        "source": "auto",
        "name": "StartTime",
        "value": otherStyleTime1
    }
    arr.append(item1)
    item2 = {
        "tag": "{{EndTime}}",
        "type": "text",
        "source": "auto",
        "name": "EndTime",
        "value": otherStyleTime2
    }
    arr.append(item2)
    item3 = {
        "tag": "{{Day}}",
        "type": "text",
        "source": "auto",
        "name": "Day",
        "value": round((day2 - day1) / 24 / 60 / 60, 1)
    }
    arr.append(item3)
    if 'reportconfig' in report['basedata']:
        reportconfig = report['basedata']['reportconfig']
        #print(json.JSONEncoder().encode(reportconfig))
        for metric in reportconfig:
            #print(metric)
            is_auto = False
            if 'source' in metric:
                if "auto" == metric['source']:
                    is_auto = True
            if is_auto:
                # print(metric)
                myitem = auto(state, start, end, metric)
                if None != myitem:
                    arr.append(myitem)
            else:
                arr.append(metric)
    return arr

def auto(state, start, end,metric):
    if metric['type'] == "text":
        if metric['expr'] != []:
            content = get_prometheus_query(state['host'], metric['expr'], start, end, '15s')
            # print(content)
            if content['data']['result'] != []:
                value = content['data']['result'][0]['value'][1]
                items = {
                    "type": "text",
                    "name": metric['name'],
                    "value": value
                }

            return items

    if metric['type'] == 'image':
        # print(url)
        items = {
            "type": "image",
            "name": metric['name'],
            "url": metric['url'] + "&from=" + start + "&to=" + end,
            "width": 500,
            "height": 250
            }
        return items

def post(args, session, env):
    '''zeta压测报告API实现'''
    body = json.loads(base64.b64decode(args).decode("utf-8"))
    print(body)
    state = json.loads(base64.b64decode(env).decode("utf-8"))
    print(state)
    data = get_single_grafana_data(body['uid'], body['job'], body['instance'], state['host'])
    result = json.JSONEncoder().encode(data)
    enbody = base64.b64encode(result.encode('utf-8'))
    return enbody


def get(args, session, env):
    '''zeta压测报告API实现'''
    body = json.loads(base64.b64decode(args).decode("utf-8"))
    state = json.loads(base64.b64decode(env).decode("utf-8"))
    #print(body)
    # # 根据body['templateurl'] 和 json串 生成报告
    # http://124.156.217.175/report/WordController/replaceWord
    templateUrl = body['templateurl']
    wordbody = {
        "templateUrl": templateUrl,
        "wordName": "zetam123",
        "datas": get_json(args, session, env)
    }
    print(json.JSONEncoder().encode(wordbody))
    url = 'http://' + state['host'] + '/report/WordController/replaceWord'
    #print(url)
    s.headers.update({'Accept': '*/*', 'Accept-Encoding': 'gzip, deflate', 'Content-Type': 'application/json'})
    r = s.post(url, data=json.dumps(wordbody))
    #print(r.content)
    localtime = time.strftime("%Y-%m-%d-%H-%M-%S", time.localtime())
    word_file_name = body['reportid'] + '_' + localtime + '.docx'
    with open(word_file_name, 'wb') as f:
        f.write(r.content)
    path = upload(word_file_name, session, state)
    #print(path)
    # path = '/shapes/凸版市场部/20210109/15/03/4/1b716807eb_2021-01-09-15-03-18.docx'
    topic = session + '/' + 'get_' + get_mod()
    #print(topic)
    payload = 'http://' + state['host'] + path
    # publish(topic, payload, state['host'])
    s.headers.update({"sessionToken": session, 'Content-Type': 'application/json'})
    rt = s.get('http://' + state['host'] + '/iotapi/classes/Device?order=createdAt&limit=1&skip=0',
               params={'keys': 'basedata', 'where': json.dumps({"objectId": body['reportid']})})
    report = json.loads(rt.content)['results'][0]
    docxInfo = []
    # payload = 'http://124.156.217.175/shapes/凸版市场部/1b716807eb_2021-01-09-19-41-11.docx'
    #print(payload)
    if 'docxInfo' in report['basedata']:
        docxInfo = report['basedata']['docxInfo']
    item = {
        'timestamp': str(int(time.time())),
        'docxUrl':payload
    }
    #print(docxInfo)
    docxInfo.append({
        'timestamp': str(int(time.time())),
        'docxUrl':payload
    })
    newdoxInfo = {
       'docxInfo': docxInfo
    }
    newbasedata = dict(report['basedata'], **newdoxInfo)
    data = {
        "basedata": newbasedata
    }
    #print(json.JSONEncoder().encode(data))
    s.headers.update({"sessionToken": session, 'Content-Type': 'application/json'})
    rt = s.put('http://' + state['host'] + '/iotapi/classes/Device/' + body['reportid'], data=json.dumps(data))
    #print(rt.content)
    payload = 'http://' + state['host'] + path
    publish(topic, payload, state['host'])
    return payload

def get_mod():
    file_name = os.path.splitext(Path(__file__).name)[0]
    return 'python_' + file_name

def test_mqtt(args, session, env):
    body = json.loads(base64.b64decode(args).decode("utf-8"))
    state = json.loads(base64.b64decode(env).decode("utf-8"))
    topic = session + '/' +  get_mod() + 'get'
    print(topic)
    path = 'http://124.156.217.175/shapes/凸版市场部/1b716807eb_2021-01-09-19-41-11.docx'
    base64.b64encode(path.encode('utf-8'))
    publish('r:df994a9f9d2365fe5e4bd5187e3ea8a0/get_python_zeta_report', path, state['host'])
    print(path)
    return path


#  参数含义
# base_log：经度基准点，
# base_lat：维度基准点，
# radius：距离基准点的半径
def generate_random_gps(base_log=None, base_lat=None, radius=None):
    radius_in_degrees = radius / 111300
    u = float(random.uniform(0.0, 1.0))
    v = float(random.uniform(0.0, 1.0))
    w = radius_in_degrees * math.sqrt(u)
    t = 2 * math.pi * v
    x = w * math.cos(t)
    y = w * math.sin(t)
    longitude = y + base_log
    latitude = x + base_lat
    # 这里是想保留14位小数
    loga = '%.14f' % longitude
    lata = '%.14f' % latitude
    return loga, lata

def main():
    global groupSession
    global globalEnv
    login()

    # zeta2_0model = {
    #     "reportid": "574c943e8d",
    #     "templateurl": "http://101.32.100.234:1250/shapes/zetaDocx/中文-不加密-zeta2.docx"
    # }
    # zeta1_9model = {
    #     "reportid": "71ec1cd516",
    #     "templateurl": "http://101.32.100.234:1250/shapes/zetaDocx/中文-不加密-zeta2.docx"
    # }
    body ={#2.0
        "reportid": "574c943e8d",
        "templateurl": "http://101.32.100.234:1250/shapes/zetaDocx/0_日本語_zeta_暗号化負荷テスト.docx"
    }
    # postbody = {
    #     "job": "testcenter",
    #     "uid": "9CWBz0bik",
    #     'instance': "101.32.100.234:9100",
    #     "starttime": "1610007130000",
    #     "endtime": "1610007830000"
    # }
    # data = json.JSONEncoder().encode(postbody)

    data = json.JSONEncoder().encode(body)

    argvs = base64.b64encode(data.encode('utf-8'))
    data = json.JSONEncoder().encode(globalEnv)
    env = base64.b64encode(data.encode('utf-8'))
    # return post(argvs, groupSession, env)
    return get(argvs, groupSession, env)
    #return test_mqtt(argvs, groupSession, env)
    # longitude_, latitude_ = generate_random_gps(base_log=120.7, base_lat=30, radius=1000000)
    # print(longitude_) # 经度
    # print(latitude_)  # 纬度


def exit():
    os._exit(0)


if __name__ == "__main__":
    main()
